local addonName = ...
local core = LibStub("AceAddon-3.0"):NewAddon(addonName, "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale(addonName)

Tracker = core

core.factions = {}
core.gainsReputation = {}
core.timerReputation = false

core.currencies = nil
core.gainsCurrency = {}
core.timerCurrency = false

core.defaultColors = FACTION_BAR_COLORS
core.prettyColors = {
	[1] = {r = 0.63, g = 0.00, b = 0.00}, -- Hated
	[2] = {r = 0.63, g = 0.00, b = 0.00}, -- Hostile
	[3] = {r = 0.63, g = 0.00, b = 0.00}, -- Unfriendly
	[4] = {r = 0.82, g = 0.67, b = 0.00}, -- Neutral
	[5] = {r = 0.50, g = 0.74, b = 0.43}, -- Friendly
	[6] = {r = 0.49, g = 0.73, b = 0.42}, -- Honored
	[7] = {r = 0.47, g = 0.68, b = 0.47}, -- Revered
	[8] = {r = 0.40, g = 0.62, b = 0.40}, -- Exalted
}

core.paragonColor = { r = 0.26, g = 0.42, b = 1 }

core.defaults = {
	profile  = {
		delay = 0.5,

		reputationReplace = true,
		colors = true,
		changeReputationBar = true,

		currencyReplace = true,

	}
}


local currenciesList = {
	61, -- Dalaran Jewelcrafter's Token
	81, -- Epicurean's Award
	241, -- Champion's Seal
	361, -- Illustrious Jewelcrafter's Token
	384, -- Dwarf Archaeology Fragment
	385, -- Troll Archaeology Fragment
	391, -- Tol Barad Commendation
	393, -- Fossil Archaeology Fragment
	394, -- Night Elf Archaeology Fragment
	397, -- Orc Archaeology Fragment
	398, -- Draenei Archaeology Fragment
	399, -- Vrykul Archaeology Fragment
	400, -- Nerubian Archaeology Fragment
	401, -- Tol'vir Archaeology Fragment
	402, -- Ironpaw Token
	416, -- Mark of the World Tree
	515, -- Darkmoon Prize Ticket
	614, -- Mote of Darkness
	615, -- Essence of Corrupted Deathwing
	676, -- Pandaren Archaeology Fragment
	677, -- Mogu Archaeology Fragment
	697, -- Elder Charm of Good Fortune
	738, -- Lesser Charm of Good Fortune
	752, -- Mogu Rune of Fate
	754, -- Mantid Archaeology Fragment
	776, -- Warforged Seal
	777, -- Timeless Coin
	789, -- Bloody Coin
	821, -- Draenor Clans Archaeology Fragment
	823, -- Apexis Crystal
	824, -- Garrison Resources
	828, -- Ogre Archaeology Fragment
	829, -- Arakkoa Archaeology Fragment
	910, -- Secret of Draenor Alchemy
	944, -- Artifact Fragment
	980, -- Dingy Iron Coins
	994, -- Seal of Tempered Fate
	999, -- Secret of Draenor Tailoring
	1008, -- Secret of Draenor Jewelcrafting
	1017, -- Secret of Draenor Leatherworking
	1020, -- Secret of Draenor Blacksmithing
	1101, -- Oil
	1129, -- Seal of Inevitable Fate
	1149, -- Sightless Eye
	1154, -- Shadowy Coins
	1155, -- Ancient Mana
	1166, -- Timewarped Badge
	1171, -- Artifact Knowledge
	1172, -- Highborne Archaeology Fragment
	1173, -- Highmountain Tauren Archaeology Fragment
	1174, -- Demonic Archaeology Fragment
	1191, -- Valor
	1220, -- Order Resources
	1226, -- Nethershard
	1268, -- Timeworn Artifact
	1273, -- Seal of Broken Fate
	1275, -- Curious Coin
	1299, -- Brawler's Gold
	1314, -- Lingering Soul Fragment
	1324, -- Horde Qiraji Commendation
	1325, -- Alliance Qiraji Commendation
	1342, -- Legionfall War Supplies
	1347, -- Legionfall Building - Personal Tracker - Mage Tower (Hidden)
	1349, -- Legionfall Building - Personal Tracker - Command Tower (Hidden)
	1350, -- Legionfall Building - Personal Tracker - Nether Tower (Hidden)
	1355, -- Felessence
	1356, -- Echoes of Battle
	1357, -- Echoes of Domination
	1379, -- Trial of Style Token
	1388, -- Armor Scraps
	1401, -- Stronghold Supplies
	1416, -- Coins of Air
	1501, -- Writhing Essence
	1506, -- Argus Waystone
	1508, -- Veiled Argunite
	1533, -- Wakening Essence
	1534, -- Zandalari Archaeology Fragment
	1535, -- Drust Archaeology Fragment
	1540, -- Wood
	1541, -- Iron
	1553, -- Azerite
	1559, -- Essence of Storms
	1560, -- War Resources
	1565, -- Rich Azerite Fragment
	1579, -- Champions of Azeroth
	1580, -- Seal of Wartorn Fate
	1585, -- Honor
	1586, -- Honor Level
	1587, -- War Supplies
	1592, -- Order of Embers
	1593, -- Proudmore Admiralty
	1594, -- Storm's Wake
	1595, -- Talanji's Expedition
	1596, -- Voldunai
	1597, -- Zandalari Empire
	1598, -- Tortollan Seekers
	1599, -- 7th Legion
	1600, -- Honorbound
	1602, -- Conquest
	1703, -- BFA Season 1 Rated Participation Currency
	1704, -- Spirit Shard
	1705, -- Warfronts - Personal Tracker - Iron in Chest (Hidden)
	1710, -- Seafarer's Dubloon
}




function core:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("TrackerDB", self.defaults, true)

	self:RegisterEvent("PLAYER_ENTERING_WORLD", "WorldEnter")
	self:RegisterEvent("ADDON_LOADED", "Loaded")

	self:RegisterEvent("CURRENCY_DISPLAY_UPDATE", "CurrenciesPreChanges")

	ChatFrame_AddMessageEventFilter("CHAT_MSG_COMBAT_FACTION_CHANGE", _ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CURRENCY", _ChatFilter)

	hooksecurefunc("ReputationFrame_Update", core.ReputationFrame_Update)
end

function core:Loaded()
	self:UnregisterEvent("ADDON_LOADED")
	self:updateColors()
end

function core:WorldEnter()
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self.factions = self:GetFactions()
	self.currencies = self:GetCurrencies()


	-- for i = 1, 100 do
		-- local bar = _G["ReputationBar"..i]
		-- if bar ~= nil then
			-- if bar.tooltip ~= nil and bar.hasRep then
				-- local OnEnter = bar:GetScript("OnEnter")
				-- bar:SetScript("OnEnter", function(self)
					-- local
						-- name,
						-- description,
						-- standingId,
						-- barMin,
						-- barMax,
						-- barValue,
						-- atWarWith,
						-- canToggleAtWar,
						-- isHeader,
						-- isCollapsed,
						-- hasRep,
						-- isWatched,
						-- isChild,
						-- factionID,
						-- hasBonusRepGain,
						-- canBeLFGBonu
							-- = GetFactionInfo(self.index)
					-- if self.standingText ~= nil and factionID ~= nil then
						-- GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT", 5, 20)
						-- GameTooltip:SetText(name, 1, .82, 0, true)
						-- GameTooltip:AddLine(self.standingText, 1, 1, 1, true)
						-- currentAmount = barValue - barMin;
						-- currentMax = barMax - barMin;
						-- GameTooltip:AddLine(L["left"]:gsub("^%l", string.upper)..": "..(currentMax - currentAmount), 1, 1, 1, true)

						-- GameTooltip:Show()
					-- end
					-- OnEnter(self)
				-- end)
				-- local OnLeave = bar:GetScript("OnLeave")
				-- bar:SetScript("OnLeave", function(self)
					-- GameTooltip:Hide()
					-- OnLeave(self)
				-- end)
			-- end
		-- end
	-- end
end

function core:updateColors()
	if self.db.profile.colors then
		FACTION_BAR_COLORS = self.prettyColors
	else
		FACTION_BAR_COLORS = self.defaultColors
	end
end

function core:ReputationFrame_Update(...)
	local numFactions = GetNumFactions()
	local factionOffset = FauxScrollFrame_GetOffset(ReputationListScrollFrame)

	for i = 1, NUM_FACTIONS_DISPLAYED do
		local factionIndex = factionOffset + i
		local factionRow = _G["ReputationBar"..i]
		local factionBar = _G["ReputationBar"..i.."ReputationBar"]

		if factionIndex <= numFactions then
			local _, _, standingID, _, _, _, _, _, _, _, _, _, _, factionID = GetFactionInfo(factionIndex)

			if not standingID == MAX_REPUTATION_REACTION then return end

			if factionID and C_Reputation.IsFactionParagon(factionID) then
				local currentValue, threshold, _, hasRewardPending = C_Reputation.GetFactionParagonInfo(factionID)
				local value = mod(currentValue, threshold)
				if hasRewardPending then
					value = value + threshold
				end
				factionRow.rolloverText = HIGHLIGHT_FONT_COLOR_CODE.." "..format(REPUTATION_PROGRESS_FORMAT, value, threshold)..FONT_COLOR_CODE_CLOSE

				factionBar:SetMinMaxValues(0, threshold)
				factionBar:SetValue(value)
				factionBar:SetStatusBarColor(core.paragonColor.r, core.paragonColor.g, core.paragonColor.b)
			end
		end
	end
end

function _ChatFilter(self, event, msg, ...)
	local skip = false
	if event == "CHAT_MSG_COMBAT_FACTION_CHANGE" then
		if string.match(msg, "%d") == nil then
			-- matched paragon reputation
			skip = false
		else
			if core.db.profile.delay > 0 then
				if core.timerReputation ~= nil then
					core:CancelTimer(core.timerReputation)
				end
				core.timerReputation = core:ScheduleTimer("FactionsChanges", core.db.profile.delay)
			else
				core:FactionsChanges()
			end
			skip = core.db.profile.reputationReplace
		end
	elseif event == "CHAT_MSG_CURRENCY" then
		skip = core.db.profile.currencyReplace
	end
	return skip, msg, ...
end

function core:CurrenciesPreChanges()
	if self.db.profile.delay > 0 then
		if self.timerCurrency ~= nil then
			self:CancelTimer(self.timerCurrency)
		end
		self.timerCurrency = self:ScheduleTimer("CurrenciesChanges", self.db.profile.delay)
	else
		self:CurrenciesChanges()
	end
end

function core:FactionsChanges()
	local factions = self.GetFactions()

	for i, new in pairs(factions) do
		if self.gainsReputation[i] == nil then
			self.gainsReputation[i] = 0
		end
		if self.factions[i] ~= nil then
			if not self.factions[i].paragon then
				local old = self.factions[i]
				local diff = new.barValue - old.barValue
				if diff ~= 0 then
					self.gainsReputation[i] = self.gainsReputation[i] + diff
					self:PrintReputation(new, diff, false)
				end
			else
				local old = self.factions[i]
				local diff = new.paragonValue - old.paragonValue
				if diff ~= 0 then
					self.gainsReputation[i] = self.gainsReputation[i] + diff
					self:PrintReputation(new, diff, false)
				end
			end
		else
			self.gainsReputation[i] = new.barValue
			self:PrintReputation(new, new.barValue, true)
		end

	end
	self.factions = factions
end

function core:CurrenciesChanges()
	if self.currencies == nil then
		return
	end

	local currencies = self.GetCurrencies()

	for i, new in pairs(currencies) do
		if self.gainsCurrency[i] == nil then
			self.gainsCurrency[i] = 0
		end
		if self.currencies[i] ~= nil then
			local old = self.currencies[i]
			local diff = new.currentAmount - old.currentAmount
			if diff ~= 0 then
				self.gainsCurrency[i] = self.gainsCurrency[i] + diff
				self:PrintCurrency(new, diff, false)
			end
		else
			self.gainsCurrency[i] = new.currentAmount
			self:PrintCurrency(new, new.currentAmount, true)
		end

	end
	self.currencies = currencies
end

function core:PrintReputation(new, diff, newFaction)
	local color = {
		main = "|cFF8080ff",
		off = "|cFFA7A7ff",
		points = "",
		gain = "|cFF40ff40",
		loss = "|cFFff4040"
	}

	local total = self.gainsReputation[new.factionID]

	if diff == 0 then
		return
	elseif diff > 0 then
		color.points = color.gain
	else
		color.points = color.loss
	end

	local str = color.main .. new.name .. ": " .. color.points .. diff .. " p." .. color.main

	if not newFaction then
		str = str .. color.off .. "  (" .. L["session"] .. ": " .. total .. ", " .. L["left"] .. ": "
		if not new.paragon then
			str = str .. new.currentNext .. " "  .. new.intervalNextName .. ")"
		else
			local paragonValue = new.paragonValue % 10000;
			local paragonNext = new.paragonNext - paragonValue;
			str = str .. paragonNext .. " Paragon)"
		end
	end

	if core.db.profile.reputationReplace then
		self:_Print(str)
	end

	if self.db.profile.changeReputationBar then
		SetWatchedFactionIndex(new.index)
	end
end

function core:PrintCurrency(new, diff, newCurrency)
	local color = {
		main = "|cFF00aa00",
		off = "|cFF42cf42",
		points = "",
		gain = "|cFF40ff40",
		loss = "|cFFff4040"
	}

	local total = self.gainsCurrency[new.index]

	if diff == 0 then
		return
	elseif diff > 0 then
		color.points = color.main
	else
		color.points = color.loss
		diff =  0 - diff
	end

	local str = new.link .. color.main .. ": " .. color.points .. "x" .. diff .. "" .. color.main .. ". "


	str = str .. color.off .. "("

	str = str .. L["session"] .. ": " .. total .. ", "

	str = str .. L["total"] .. ": " .. new.currentAmount
	if new.totalMax > 0 then
		str = str .. "/" .. new.totalMax
	end

	str = str .. ")"

	-- if not newCurrency then
		-- str = str .. color.off .. "  (session: " .. total .. ", left: "  .. new.currentNext .. " "  .. new.intervalNextName .. ")"
	-- end

	if core.db.profile.currencyReplace then
		self:_Print(str)
	end
end

function core:GetFactions()
	local factions = {};

	ExpandAllFactionHeaders();

	for i = 1, GetNumFactions() do
		local
			name,
			description,
			standingId,
			barMin,
			barMax,
			barValue,
			atWarWith,
			canToggleAtWar,
			isHeader,
			isCollapsed,
			hasRep,
			isWatched,
			isChild,
			factionID,
			hasBonusRepGain,
			canBeLFGBonus
				= GetFactionInfo(i)

		if not isHeader and factionID ~= nil then



			if barValue == nil then
				barValue = 0;
			end

			local standingNextId = standingId + 1
			if standingNextId > 8 then standingNextId = 8 end
			local standingName = _G["FACTION_STANDING_LABEL" .. standingId];
			local standingNextName = _G["FACTION_STANDING_LABEL" .. standingNextId];

			local currentAmount = barValue - barMin;
			local currentMax = barMax - barMin;

			local paragon, paragonValue, paragonNext, paragonQuest, paragonReward = C_Reputation.IsFactionParagon(factionID), 0, 0, nil, false
			if paragon then
				paragonValue, paragonNext, paragonQuest, paragonReward = C_Reputation.GetFactionParagonInfo(factionID);

				if paragonReward then
					core:_Print("|cFF8080ff" .. name .. "|r has a paragon reward!")
				end

			end

			local faction = {
				factionID = factionID,
				index = i,
				name = name,

				intervalId = standingId,
				intervalName= standingName,
				intervalNextId = standingNextId,
				intervalNextName = standingNextName,

				current = currentAmount,
				currentMax = currentMax,
				currentNext = currentMax - currentAmount,

				barMin = barMin,
				barMax = barMax,
				barValue = barValue,

				paragon = paragon,
				paragonValue = paragonValue,
				paragonNext = paragonNext,
				paragonQuest = paragonQuest,
				paragonReward = paragonReward,

			}

			factions[factionID] = faction

		end
	end

	return factions

end

function core:GetCurrencies()
	local currencies  = {};

	for _,id in pairs(currenciesList) do
		local name, currentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered, rarity = GetCurrencyInfo(id);

		if name ~= nil and isDiscovered then

			local currency = {
				index = id,
				name = name,
				texture = texture,
				link = GetCurrencyLink(id, currentAmount),
				rarity = rarity,

				currentAmount = currentAmount,

				weekAmount = earnedThisWeek,
				weeklMax = weeklyMax,

				totalMax = totalMax,

				isDiscovered = isDiscovered
			}

			currencies[id] = currency
		end
	end

	return currencies;
end

function core:_Print(...)
	DEFAULT_CHAT_FRAME:AddMessage(...)
end

function core:debug(tData)
	if ViragDevTool_AddData then
		ViragDevTool_AddData(tData, "debug")
	end
end
